#   ____ ___  _   ___   ____  __
#  / ___/ _ \| \ | \ \ / /\ \/ /
# | |  | | | |  \| |\ V /  \  /
# | |__| |_| | |\  | | |   /  \
#  \____\___/|_| \_| |_|  /_/\_\
#
# Console Nyx Client
#
# Nyx TUI Main Screen
#
# version 0.0.8 beta
#
# You can do whatever You want with Conyx.
# But I don't take reponsbility nor even
# implied responsibility for the negative
# impact of Your acting.
#


import sys, os, traceback
import curses
sys.path.insert(0, (os.environ['CONYX']+'/lib'))
from tuiBuffer import tuiBuffer 
from tuiFile import tuiFile
from nyxOp import *

def draw_menu(stdscr):
  k = 0
  cursor_x = 0
  cursor_y = 0

  # Clear and refresh the screen for a blank canvas
  stdscr.clear()
  stdscr.refresh()

  # Start colors in curses
  curses.start_color()
  curses.init_pair(1, curses.COLOR_CYAN, curses.COLOR_BLACK)
  curses.init_pair(2, curses.COLOR_RED, curses.COLOR_BLACK)
  curses.init_pair(3, curses.COLOR_BLACK, curses.COLOR_WHITE)

  # Loop where k is the last character pressed
  while (k != ord('q')):

    # Initialization
    stdscr.clear()
    height, width = stdscr.getmaxyx()

    if k == curses.KEY_DOWN:
      cursor_y = cursor_y + 1
    elif k == curses.KEY_UP:
      cursor_y = cursor_y - 1
    elif k == curses.KEY_RIGHT:
      cursor_x = cursor_x + 1
    elif k == curses.KEY_LEFT:
      cursor_x = cursor_x - 1
    elif k == 122: # Z - zmeny
      try:
        tuiFile("CHANGELOG") 
      except Exception:
        print("Nemuzu zobrazit seznam zmen.")
    elif k == 115: # S - sledovane
      try:
        disp=""
        buf=nyx_list_disc('nove',0)
        for ln in buf:
          disp+=ln+'\n' 
        tuiBuffer('nove',disp)
      except Exception:
        traceback.print_exc(file=sys.stdout)
        input("Zmackni Enter ...")
        print("Nemuzu zobrazit seznam sledovanych.")
    elif k == 99: # C - cti
      try:
        disp=""
        #buf=nyx_list_disc('nove',0)
        buf=nyx_show_disc_msgs(str(1),0) ### TODO FROM INPUT
        for ln in buf:
          disp+=ln+'\n' 
        tuiBuffer('nove',disp)
      except Exception:
        traceback.print_exc(file=sys.stdout)
        input("Zmackni Enter ...")
        print("Nemuzu zobrazit seznam sledovanych.")



    cursor_x = max(0, cursor_x)
    cursor_x = min(width-1, cursor_x)

    cursor_y = max(0, cursor_y)
    cursor_y = min(height-1, cursor_y)

    # Declaration of strings
    title = "CONYX"[:width-1]
    subtitle = "CONSOLE NYX CLIENT"[:width-1]
    keystr = "Posledni klavesa: {}".format(k)[:width-1]
    statusbarstr = "Press 'q' to exit | STATUS BAR | Pos: {}, {}".format(cursor_x, cursor_y)
    credits = "GIOMIKY MMXVIII"
    if k == 0:
      keystr = "Nezaznamenal jsem stisk klavesy..."[:width-1]

    # Centering calculations
    start_x_title = int((width // 2) - (len(title) // 2) - len(title) % 2)
    start_x_subtitle = int((width // 2) - (len(subtitle) // 2) - len(subtitle) % 2)
    start_x_keystr = int((width // 2) - (len(keystr) // 2) - len(keystr) % 2)
    start_x_credits = int((width // 2) - (len(credits) // 2) - len(credits) % 2)
    start_y = int((height // 2) - 2)

    # Rendering some text
    whstr = "Width: {}, Height: {}".format(width, height)
    stdscr.addstr(0, 0, whstr, curses.color_pair(1))

    # Render status bar
    stdscr.attron(curses.color_pair(3))
    stdscr.addstr(height-1, 0, statusbarstr)
    stdscr.addstr(height-1, len(statusbarstr), " " * (width - len(statusbarstr) - 1))
    stdscr.attroff(curses.color_pair(3))

    # Turning on attributes for title
    stdscr.attron(curses.color_pair(2))
    stdscr.attron(curses.A_BOLD)

    # Rendering title
    stdscr.addstr(start_y, start_x_title, title)

    # Turning off attributes for title
    stdscr.attroff(curses.color_pair(2))
    stdscr.attroff(curses.A_BOLD)

    # Print rest of text
    stdscr.addstr(start_y + 1, start_x_subtitle, subtitle)
    stdscr.addstr(start_y + 3, (width // 2) - 2, '-' * 4)
    stdscr.addstr(start_y + 5, start_x_keystr, keystr)
    stdscr.addstr(start_y + 7, start_x_credits, credits)
    stdscr.move(cursor_y, cursor_x)

    # Refresh the screen
    stdscr.refresh()

    # Wait for next input
    k = stdscr.getch()

def tuiMainScreen():
  curses.wrapper(draw_menu)

# DEBUG
#tuiMainScreen()
